<?
/*

 activeGallery_nm

 free script that makes photo album from images in current directory and sub-directories.

 Modified 2005 by Nate Murray
 based on activeGallery_nm Copyright (C) 2005 ActiveUnit.com

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/*
TODO: 
# accept comments in the parsing of the files.txt

*/

// GALLERY SETTINGS

Define('DIR_CACHE', './tmp/'); // directory to store modified images (shoul have right to write files)
Define('THUMBNAIL_WIDTH', '240'); // thumbnails width
Define('THUMBNAIL_HEIGHT', '240'); // thumbnails height
Define('IMAGES_ROW', 3); // images on row

// ----------------------------------------------------------------------

$img= empty($_GET['img']) ? "" : $_GET['img'];

if (!Is_Dir(DIR_CACHE)) {
 mkdir(DIR_CACHE, 0777);
}

// IMAGE RESIZE AND SAVE TO FIT IN $new_width x $new_height
if ($img!='' && file_exists($img)) {

 $w=$_GET['w'];
 $h=$_GET['h'];

 $thumb=strtolower(preg_replace('/\W/is', "_", "$img $w $h"));

  $changed=0;
  if (file_exists($img) && file_exists(DIR_CACHE.$thumb)) {
   $mtime1=filemtime(DIR_CACHE.$thumb);
   $mtime2=filemtime($img);
   if ($mtime2>$mtime1) $changed=1;
  } elseif (!file_exists(DIR_CACHE.$thumb)) {
   $changed=1;
  }

 if ($changed) {

 $filename=$img;
 $new_width=(int)@$w;
 $new_height=(int)@$h;
 $lst=GetImageSize($filename);
 $image_width=$lst[0];
 $image_height=$lst[1];
 $image_format=$lst[2];

 if ($image_format==1) {
   Header("Content-Type:image/gif");
   readfile($filename);
   exit;
 } elseif ($image_format==2) {
  $old_image=imagecreatefromjpeg($filename);
 } elseif ($image_format==3) {
  $old_image=imagecreatefrompng($filename);
 } else {
  exit;
 }

 if (($new_width!=0) && ($new_width<$image_width)) {
  $image_height=(int)($image_height*($new_width/$image_width));
  $image_width=$new_width;
//  $image_height=$new_height;
 }

 if (($new_height!=0) && ($new_height<$image_height)) {
  $image_width=(int)($image_width*($new_height/$image_height));
  $image_height=$new_height;
//  $image_width=$new_width;
 }


//  $new_image=imageCreate($image_width, $image_height); // for old GDlib
 $new_image=imageCreateTrueColor($image_width, $image_height);

 $white = ImageColorAllocate($new_image, 255, 255, 255);
 ImageFill($new_image, 0, 0, $white);

// imagecopyresampled
// imageCopyResized (for old GDlib)
 imageCopyResampled( $new_image, $old_image, 0, 0, 0, 0, $image_width, $image_height, imageSX($old_image), imageSY($old_image));

 imageJpeg($new_image, DIR_CACHE.$thumb);
 }


 Header("Content-type:image/jpeg");
 readfile(DIR_CACHE.$thumb);
 exit;
}

// ----------------------------------------------------------------------

  $init_dir="./";

  if (IsSet($_GET['dir'])) {
   $dir=$_GET['dir'];
   $dir=preg_replace("/\.+/", ".", $dir);
   $dir=preg_replace("/^\//", "", $dir);
  }

  #if (IsSet($dir) && ($dir!=$init_dir)) {
  if (!empty($dir) && ($dir!=$init_dir) && is_dir($dir) ) {
   $directory=$dir;
   #print "Directory: $dir\n";
   $tmp=array_reverse(explode('/', $dir));
   array_shift($tmp);
   array_shift($tmp);
   $out['UP']=urlencode(implode('/', array_reverse($tmp))."/");
  } else {
   $directory=$init_dir;
  }

  $dir=opendir($directory);
  $k=0;
  $on_row=IMAGES_ROW;

  // Load our image names
  $NOTATIONS = "files.txt"; # STATIC
  $descriptions = parse_names($directory . $NOTATIONS);


  while ($file=readdir($dir)) { 
   if (Is_Dir($directory."/$file") && ($file!='tmp') && ($file!='.') && ($file!='..') && (!preg_match("/^_/", $file)) ) {
    $directories[]=array('FILENAME'=>$file, 'DIR'=>$directory, 'URL'=>urlencode($directory."$file/"),
                         'DESCRIPTION' =>  !empty($descriptions[$file]) ? $descriptions[$file] : "" ); #could be '$file'
   }
   
   if (!Is_file($directory."/$file")) continue;

   $ext=strtolower(substr($file, -3));

   if ($ext!='gif' && $ext!='jpg') continue;

   $rec=array();
   $rec["FILENAME"]=$file;

   $size=(int)(filesize($directory."/".$file)/1024);
   if ($size>1024) {
    $rec["SIZE"]=(((int)($size*100/1024))/100)." Mb";
   } else {
    $rec["SIZE"]=$size." Kb";
   }
   if (IsSet($descriptions[$file])) {
    $rec['DESCRIPTION']=$descriptions[$file];
   }
   $rec["DIR"]=$directory;
   if (($k+1)%$on_row==0) {
    $rec['NEXT_ROW']=1;
   }
   $k++;
   $files[]=$rec;
  }
  include('./template.php');

// ----------------------------------------------------------------------

function parse_names($where) 
{
  $descriptions = array();
  if (file_exists($where)) {
    $data=LoadFile($where);
    $lines=explode("\n", $data);
    for($i=0;$i<count($lines);$i++) {
      $ar=explode(' ', trim($lines[$i]));
      $tmp=array_shift($ar);
      $descriptions[$tmp]=implode(' ', $ar);
    }
  }
 return $descriptions;
}

function LoadFile($filename) 
{
 // loading file
 $f=fopen("$filename", "r");
 $data="";
 if ($f) {
  $data=fread($f, filesize($filename));
  fclose($f);
 }
 return $data;
}

function thumbnail($f) 
{
  $nail = "<br class='clear'/>";
  $t = "<div class='thumbnail'><div class='shadow'><div class='border'><a href='%s'><img src='%s' alt='%s'  border=0 /></div><div class='topleft'></div><div class='topright'></div><div class='bottomleft'></a></div><div class='bottomright'></div></div>%s</div>"; 
  $desc = !empty($f['DESCRIPTION']) ? $f['DESCRIPTION'] : "";
  $cap = "<div class='caption'>%s</div>";
  return sprintf("$t\n", $f['DIR'] . $f['FILENAME'],  
                  "?img=".$f['DIR']. $f['FILENAME']."&w=".THUMBNAIL_WIDTH."&h=".THUMBNAIL_HEIGHT, $desc,
                  $desc ? sprintf($cap, $desc) : "") ;
}

function nav($v)
{
  $r = "<li class='picnav'><a href='?dir=". $v['URL'] ."'>";
  if (!empty($v['DESCRIPTION'])) $r .= $v['DESCRIPTION'];
  else                           $r .= $v['FILENAME'];
  $r .= "</a></li>"; 
  return $r;
}

?>
